require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_X86_INSN_H)) {
    eval 'sub _ASM_X86_INSN_H () {1;}' unless defined(&_ASM_X86_INSN_H);
    require 'asm/inat.ph';
    eval 'sub X86_MODRM_MOD {
        my($modrm) = @_;
	    eval q(((($modrm) & 0xc0) >> 6));
    }' unless defined(&X86_MODRM_MOD);
    eval 'sub X86_MODRM_REG {
        my($modrm) = @_;
	    eval q(((($modrm) & 0x38) >> 3));
    }' unless defined(&X86_MODRM_REG);
    eval 'sub X86_MODRM_RM {
        my($modrm) = @_;
	    eval q((($modrm) & 0x7));
    }' unless defined(&X86_MODRM_RM);
    eval 'sub X86_SIB_SCALE {
        my($sib) = @_;
	    eval q(((($sib) & 0xc0) >> 6));
    }' unless defined(&X86_SIB_SCALE);
    eval 'sub X86_SIB_INDEX {
        my($sib) = @_;
	    eval q(((($sib) & 0x38) >> 3));
    }' unless defined(&X86_SIB_INDEX);
    eval 'sub X86_SIB_BASE {
        my($sib) = @_;
	    eval q((($sib) & 0x7));
    }' unless defined(&X86_SIB_BASE);
    eval 'sub X86_REX_W {
        my($rex) = @_;
	    eval q((($rex) & 8));
    }' unless defined(&X86_REX_W);
    eval 'sub X86_REX_R {
        my($rex) = @_;
	    eval q((($rex) & 4));
    }' unless defined(&X86_REX_R);
    eval 'sub X86_REX_X {
        my($rex) = @_;
	    eval q((($rex) & 2));
    }' unless defined(&X86_REX_X);
    eval 'sub X86_REX_B {
        my($rex) = @_;
	    eval q((($rex) & 1));
    }' unless defined(&X86_REX_B);
    eval 'sub X86_VEX_W {
        my($vex) = @_;
	    eval q((($vex) & 0x80));
    }' unless defined(&X86_VEX_W);
    eval 'sub X86_VEX_R {
        my($vex) = @_;
	    eval q((($vex) & 0x80));
    }' unless defined(&X86_VEX_R);
    eval 'sub X86_VEX_X {
        my($vex) = @_;
	    eval q((($vex) & 0x40));
    }' unless defined(&X86_VEX_X);
    eval 'sub X86_VEX_B {
        my($vex) = @_;
	    eval q((($vex) & 0x20));
    }' unless defined(&X86_VEX_B);
    eval 'sub X86_VEX_L {
        my($vex) = @_;
	    eval q((($vex) & 0x4));
    }' unless defined(&X86_VEX_L);
    eval 'sub X86_VEX3_M {
        my($vex) = @_;
	    eval q((($vex) & 0x1f));
    }' unless defined(&X86_VEX3_M);
    eval 'sub X86_VEX2_M () {1;}' unless defined(&X86_VEX2_M);
    eval 'sub X86_VEX_V {
        my($vex) = @_;
	    eval q(((($vex) & 0x78) >> 3));
    }' unless defined(&X86_VEX_V);
    eval 'sub X86_VEX_P {
        my($vex) = @_;
	    eval q((($vex) & 0x3));
    }' unless defined(&X86_VEX_P);
    eval 'sub X86_VEX_M_MAX () {0x1f;}' unless defined(&X86_VEX_M_MAX);
    if(defined(&CONFIG_X86_64)) {
    } else {
    }
    eval 'sub insn_is_avx {
        my($insn) = @_;
	    eval q({  &if (! ($insn->{prefixes}->{got}))  &insn_get_prefixes($insn); ( ($insn->{vex_prefix}->{value}) != 0); });
    }' unless defined(&insn_is_avx);
    eval 'sub insn_vex_m_bits {
        my($insn) = @_;
	    eval q({  &if ( ($insn->{vex_prefix}->{nbytes}) == 2)  &X86_VEX2_M;  &else  &X86_VEX3_M( ($insn->{vex_prefix}->{bytes[1]})); });
    }' unless defined(&insn_vex_m_bits);
    eval 'sub insn_vex_p_bits {
        my($insn) = @_;
	    eval q({  &if ( ($insn->{vex_prefix}->{nbytes}) == 2)  &X86_VEX_P( ($insn->{vex_prefix}->{bytes[1]}));  &else  &X86_VEX_P( ($insn->{vex_prefix}->{bytes[2]})); });
    }' unless defined(&insn_vex_p_bits);
    eval 'sub insn_offset_vex_prefix {
        my($insn) = @_;
	    eval q({  &insn_offset_rex_prefix($insn) +  ($insn->{rex_prefix}->{nbytes}); });
    }' unless defined(&insn_offset_vex_prefix);
    eval 'sub insn_offset_opcode {
        my($insn) = @_;
	    eval q({  &insn_offset_vex_prefix($insn) +  ($insn->{vex_prefix}->{nbytes}); });
    }' unless defined(&insn_offset_opcode);
    eval 'sub insn_offset_modrm {
        my($insn) = @_;
	    eval q({  &insn_offset_opcode($insn) +  ($insn->{opcode}->{nbytes}); });
    }' unless defined(&insn_offset_modrm);
    eval 'sub insn_offset_sib {
        my($insn) = @_;
	    eval q({  &insn_offset_modrm($insn) +  ($insn->{modrm}->{nbytes}); });
    }' unless defined(&insn_offset_sib);
    eval 'sub insn_offset_displacement {
        my($insn) = @_;
	    eval q({  &insn_offset_sib($insn) +  ($insn->{sib}->{nbytes}); });
    }' unless defined(&insn_offset_displacement);
    eval 'sub insn_offset_immediate {
        my($insn) = @_;
	    eval q({  &insn_offset_displacement($insn) +  ($insn->{displacement}->{nbytes}); });
    }' unless defined(&insn_offset_immediate);
}
1;
